=== debian/changelog ===
dlt-daemon (2.18.6-2) unstable; urgency=medium

  * Enable and run unit tests during build step:
    - b-d on libgtest-dev
    - patch cmake to run the system gtest version without rebuilding it

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 Apr 2021 18:35:22 +0200

dlt-daemon (2.18.6-1) unstable; urgency=medium

  * Update to new release
  * Drop all patches: upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 09 Jan 2021 14:18:44 +0100

dlt-daemon (2.18.5-0.4) unstable; urgency=medium

  * Team upload (add myself to uploaders list since I maintained it on the
    last 1.5 years and 6 uploads, Aigars please let me know if this is ok for
    you)
  * debian/patches/33fbad18c814e13bd7ba2053525d8959fee437d1.patch:
  * debian/patches/ef7ca2706aa2e877c1be62d73554c6c79996d69a.patch:
    - cherry-pick two upstream commits to fix the ABI with the python-dlt one
      (unbreaking python-dlt migration and build)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 02 Dec 2020 18:39:15 +0100

dlt-daemon (2.18.5-0.3) unstable; urgency=high

  * Non-maintainer upload
  * debian/patches/275.patch:
    - cherry-pick upstream fix for CVE-2020-29394
      (Closes: #976228)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Dec 2020 21:57:59 +0100
