=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/dlt-daemon-$1\.tar\.gz/ \
  https://github.com/GENIVI/dlt-daemon/tags .*/v?(\d\S*)\.tar\.gz
